
#property copyright "Mr.T"
#property link      "www.forexprofitmatrix.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Black
#property indicator_color4 Blue
#property indicator_color5 Yellow

extern int SignalSMA = 9;
extern int CheckBars = 125;
extern int Flexibility = 2;
extern double Deviation = 2.0;
double G_ibuf_96[];
double G_ibuf_100[];
double G_ibuf_104[];
double G_ibuf_108[];
double G_ibuf_112[];
double G_point_116;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   if (Point == 0.00001) G_point_116 = 0.0001;
   else {
      if (Point == 0.001) G_point_116 = 0.01;
      else G_point_116 = Point;
   }
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexStyle(2, DRAW_NONE);
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexStyle(4, DRAW_LINE);
   IndicatorDigits(Digits);
   SetIndexBuffer(0, G_ibuf_100);
   SetIndexBuffer(4, G_ibuf_112);
   SetIndexBuffer(1, G_ibuf_104);
   SetIndexBuffer(2, G_ibuf_96);
   SetIndexBuffer(3, G_ibuf_108);
   SetIndexEmptyValue(0, 0);
   SetIndexEmptyValue(1, 0);
   SetIndexEmptyValue(2, 0);
   SetIndexEmptyValue(3, 0);
   SetIndexEmptyValue(4, 0);
   IndicatorShortName("FxCOGMaster H");
   return (0);
}
	  	    						 					 				  		 					 			 	  	  	 					  		    		     	     		 			 		 		 	 		    	 	   	  	      	 	   	       	 					 		  	     		
// 52D46093050F38C27267BCE42543EF60
int deinit() {
   return (0);
}
						 		  	    	  		 	 				 		 	     											  	 	  			 	 		 		  	 	 	 		 	             		    	 	  				 		    	 	  	 		 	   	  		 		  	 		  	
// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   double icustom_0 = 0;
   double Ld_8 = 0;
   double Ld_16 = 0;
   double Ld_24 = 0;
   int count_36 = 0;
   int Li_40 = IndicatorCounted();
   if (Li_40 > 0) Li_40--;
   int Li_32 = Bars - Li_40;
   SetLevelValue(0, 0.786 * (iCustom(Symbol(), Period(), "FxCOGMaster", CheckBars, Flexibility, Deviation, 0, 0) - iCustom(Symbol(), Period(), "FxCOGMaster", CheckBars,
      Flexibility, Deviation, 2, 0)) / G_point_116);
   SetLevelValue(1, 0.786 * (iCustom(Symbol(), Period(), "FxCOGMaster", CheckBars, Flexibility, Deviation, 1, 0) - iCustom(Symbol(), Period(), "FxCOGMaster", CheckBars,
      Flexibility, Deviation, 2, 0)) / G_point_116);
   if (Li_32 < CheckBars - 5) Li_32 = CheckBars - 5;
   for (int Li_44 = Li_32 - 1; Li_44 >= 0; Li_44--) {
      if (Li_44 > CheckBars - 5) {
         G_ibuf_96[Li_44] = 0;
         G_ibuf_112[Li_44] = 0;
      } else {
         icustom_0 = iCustom(Symbol(), Period(), "FxCOGMaster", CheckBars, Flexibility, Deviation, 2, Li_44);
         count_36 = 1;
         Ld_8 = 1.382 * (Close[Li_44] - icustom_0) / G_point_116;
         if (G_ibuf_96[Li_44 + 1] != EMPTY_VALUE) {
            Ld_8 += G_ibuf_96[Li_44 + 1];
            count_36++;
         }
         G_ibuf_96[Li_44] = Ld_8 / count_36;
         Ld_24 = MathMin(MathAbs(High[Li_44] - icustom_0) / G_point_116, MathAbs((Low[Li_44] - icustom_0) / G_point_116));
         Ld_16 = MathMax(MathAbs(High[Li_44] - icustom_0) / G_point_116, MathAbs((Low[Li_44] - icustom_0) / G_point_116));
         if (Close[Li_44] < icustom_0) {
            G_ibuf_100[Li_44] = -MathAbs(G_ibuf_96[Li_44]);
            if (1.382 * Ld_16 < MathAbs(G_ibuf_96[Li_44])) G_ibuf_104[Li_44] = -1.382 * Ld_16;
            else
               if (1.382 * Ld_24 < MathAbs(G_ibuf_96[Li_44])) G_ibuf_104[Li_44] = -1.382 * Ld_24;
            if (G_ibuf_104[Li_44] > G_ibuf_100[Li_44] - G_ibuf_104[Li_44]) G_ibuf_104[Li_44] = G_ibuf_100[Li_44] - G_ibuf_104[Li_44];
         } else {
            G_ibuf_100[Li_44] = MathAbs(G_ibuf_96[Li_44]);
            if (1.382 * Ld_16 < MathAbs(G_ibuf_96[Li_44])) G_ibuf_104[Li_44] = 1.382 * Ld_16;
            else
               if (1.382 * Ld_24 < MathAbs(G_ibuf_96[Li_44])) G_ibuf_104[Li_44] = 1.382 * Ld_24;
            if (G_ibuf_104[Li_44] < G_ibuf_100[Li_44] - G_ibuf_104[Li_44]) G_ibuf_104[Li_44] = G_ibuf_100[Li_44] - G_ibuf_104[Li_44];
         }
      }
   }
   for (Li_44 = 0; Li_44 < Li_32; Li_44++) G_ibuf_112[Li_44] = iMAOnArray(G_ibuf_96, Bars, SignalSMA, 0, MODE_SMA, Li_44);
   return (0);
}